D = som_read_data ('iris-som.data');

%---------------------- vizualizace -------------------------
% Here are the histograms and scatter plots of the four variables.
echo off 
k=1;
for i=1:4, 
  for j=1:4, 
    if i==j, 
      subplot (4,4,k); 
      hist (D.data(:,i)); title (D.comp_names{i})
    elseif i<j, 
      subplot (4,4,k); 
      plot (D.data(:,i),D.data(:,j),'k.')
      xlabel (D.comp_names{i})
      ylabel (D.comp_names{j})
    end
    k=k+1;
  end
end
echo on
pause
% ------------------------------------------------------------
sM = som_make (D);
pause

colormap (1-gray)
som_show (sM,'umat','all');
pause

sM = som_autolabel (sM,D,'vote');
som_show (sM,'umat','all','empty','Labels')
som_show_add ('label',sM,'Textsize',8,'TextColor','r','Subplot',2)
pause

subplot (1,1,1);
[Pd,V,me] = pcaproj (D.data,2);        % project the data
Pm        = pcaproj (sM.codebook,V,me); % project the prototypes

som_grid (sM,'Coord',Pm,'Linecolor','k');
title ('PC-projection')
pause

som_grid (sM,'Coord',Pm,'Linecolor','k','label',sM.labels,'labelcolor','r'); 
title ('PC-projection')
pause

M = som_normalize (sM.codebook,'range');
som_barplane (sM, M, '', 'unitwise');
title ('som\_barplane')
pause


som_show (sM) 
